%PAGE 68
REM ********** 
REM ********** RIGHT JUSTIFICATION OF
REM ********** PROPORTIONALLY SPACED 
REM ********** TEXT PRINTED BY 
REM ********** A CENTRONICS 737
REM ********** 

REM **********
REM ********** PROGRAMMER: MATT DWYER
REM ********** ADDRESS: FOXCROFT SCHOOL, MIDDLEBURG VA 22117
REM ********** PHONE: 703/687-5241
REM ********** 



CONSOLE
POKE 252,52

DIM THIS.LINE$(3500), CHARACTER$(256), HERES.ASPACE(256), EXTRA$(15)



DOTTY7$= "!,'().:;|" 
DOTTY8$= "il" 
DOTTY10$= "IZcfrtz{}" 
DOTTY12$ = "^$*+-/0123456789<>=?S[]\_abdeghknopqsuvxy~"
DOTTY14$=  "@CEFJLPQT&"
DOTTY15$ = "#BR" 
DOTTY16$ = "%ADGHKNOUVXYmw" 
DOTTY18$ = "MW"

DATA '"'
READ QUOTE$ 

QUOTE$ = MID$(QUOTE$,2,1)
DOTTY10$ = DOTTY10$ + QUOTE$
NULL$=LEFT$(QUOTE$,0)

FLAG$="/C/"


REM ********** 
REM ********** HELP ROUTINE
REM ********** 

GOSUB 99
PRINT "THIS PROGRAM HELPS YOU TO RIGHT JUSTIFY TEXT."
INPUT "DO YOU NEED INSTRUCTIONS? (ENTER <Y> OR <N> ) ";ANS$
IF ANS$<>"Y" AND ANS$<>"N" THEN GOSUB 99:\
  PRINT "HUH??? ENTER <Y> OR <N>, PLEASE,":\
  PRINT "WITHOUT THE <> DELIMITERS.": PRINT " ":\
  INPUT "DO YOU NEED INSTRUCTIONS? ";ANS$

IF ANS$="N" THEN GOTO 101

GOSUB 99
PRINT "FIRST OF ALL, YOU MUST PUT BEGIN FLAGS AND"
PRINT "END FLAGS IN YOUR TEXT FILE WHERE YOU WANT "
PRINT "RIGHT JUSTIFICATION TO BEGIN AND END.  "
PRINT " "
PRINT "EACH FLAG IS ONLY 3 CHARACTERS LONG:"
PRINT "THE BEGIN FLAG IS /B/, AND THE END FLAG IS /E/."
PRINT " "
PRINT "THE BEGIN FLAG MUST BE THE FIRST 3 CHARACTERS"
PRINT "IN THE LINE WHERE YOU WISH TO BEGIN RIGHT "
PRINT "JUSTIFYING.  (TYPICALLY THE FIRST LINE OF EACH "
PRINT "PARAGRAPH.)  IF YOU INDENT PARAGRAPHS, BE SURE "
PRINT "INDENT EXACTLY FIVE(5) SPACES."
PRINT " "
PRINT "THE LAST LINE TO BE RIGHT JUSTIFIED MUST HAVE "
PRINT "THE END FLAG AT THE END OF THE LINE, PRECEDED "
PRINT "BY ONE SPACE (TYPICALLY IN THE LAST LINE "
PRINT "OF EACH PARAGRAPH)."
PRINT " "
INPUT "WHEN YOU HAVE READ THIS FAR, ENTER ANY LETTER: ";LLLLLL$
GOSUB 99
PRINT "ALSO, YOU MUST REMOVE ALL SOFT HYPHENS FROM YOUR"
PRINT "TEXT FILE.  TO DO THIS USING WORDSTAR, TYPE ^O^E, "
PRINT "AND THEN USE FIND AND REPLACE TO REMOVE SOFT HYPHENS."
PRINT "BE SURE TO REJOIN ANY WORD THAT IS SPLIT BETWEEN TWO "
PRINT "LINES."
PRINT " "

PRINT "AFTER INSTALLING ALL THE FLAGS, YOU MUST PIP "
PRINT "YOUR FLAGGED TEXT FILE TO THIS PROGRAM'S DISKETTE "
PRINT "OR TO YOUR CBASIC DISKETTE.  "
PRINT " "
PRINT "BE SURE TO USE THE PIP ROUTINE WITH THE "
PRINT "[Z] OPTION IN ORDER TO CHANGE YOUR TEXT FILE "
PRINT "FOR USE BY THIS CBASIC PROGRAM."
PRINT " "
PRINT "THE PROGRAM CREATES A FILE OF EXTENSION 'RJ' WITH"
PRINT "THE FLAG '|' AT EACH POINT WHERE ONE DOT SPACE" 
PRINT "MUST BE INSERTED."
PRINT " "
PRINT "LOOK AT THIS NEW 'fname.RJ' FILE WITH WORDSTAR AND"
PRINT "FIND AND REPLACE | WITH CTRL-P CTRL-R."
PRINT " "

INPUT "WHEN YOU HAVE READ THIS FAR, ENTER ANY LETTER: ";LLLLLL$
GOSUB 99
PRINT "YOU WILL ALSO NEED TO FIND AND REPLACE THE "
PRINT "QUOTATION MARKS ('')  AT THE BEGINNING AND END OF"
PRINT "EACH STATEMENT.  DO A FIND AND REPLACE ''^P^N''"
PRINT "WITH ^P^N TO REMOVE MOST OF THEM."
PRINT " "
PRINT "(WORDSTAR USER SUBROUTINE #4 MUST BE MODIFIED"
PRINT "TO SEND 1B 01 TO THE PRINTER)."
PRINT " "
PRINT "FINALLY, YOU MAY NOTICE A LINE CONTINUATION FLAG:"
PRINT "/C/.  GET RID OF THIS FLAG JOIN THE LINE IT IS ON "
PRINT "WITH THE LINE ABOVE IT."

PRINT " "
INPUT "WHEN YOU HAVE READ THIS FAR, ENTER ANY LETTER: ";LLLLLL$
GOSUB 99
PRINT "THIS PROGRAM IS NOT VERY ELEGANT.  "
PRINT "PLEASE TELL ME IF YOU THINK OF ANY IMPROVEMENTS."
PRINT "I TRIED TO USE MNEMONIC NAMES AND HELPFUL"
PRINT "COMMENTS IN THE PROGRAM.  GOOD LUCK!!"


101  GOSUB 99: PRINT "WHAT IS THE NAME OF THE FILE "
	INPUT "THAT YOU WANT TO RIGHT JUSTIFY? ";NAME$

OPEN NAME$ AS 1
IF END# 1 THEN 105

QUIT.THIS$="/ENDOFTEXT/"



REM ********** 
REM ********** READ IN THE FILE
REM ********** TO BE RIGHT JUSTIFIED
REM ********** 

FIRST=1: NUM.LINES=300
103  FOR I = FIRST TO NUM.LINES
	THIS.LINE$(I)= QUIT.THIS$
	READ #1; LINE THIS.LINE$(I)
NEXT I

FIRST=NUM.LINES+1: NUM.LINES=NUM.LINES+100: GOTO 103


REM ********** WHEN WHOLE FILE IS READ IN, STORE NUMBER OF LINES

105  IF I = 1 THEN \
	GOSUB 99: PRINT "NO SUCH FILE": GOTO 101\
	ELSE NUM.LINES=I
CLOSE 1




REM ********** CREATE FILE TO STORE RIGHT JUSTIFIED TEXT ON

BASEPT=MATCH(".",NAME$,1)
IF BASEPT=0 THEN BASEPT=LEN(NAME$) +1
FILENAME$ = LEFT$(NAME$,BASEPT-1) + ".RJ"

CREATE FILENAME$ AS 1


GOSUB 99
PRINT "DO YOU WANT TO ENTER THE LEFT AND RIGHT "
PRINT "MARGINS? (ALTERNATIVELY, THE PROGRAM WILL"
PRINT "CALCULATE THE LENGTH OF THE LONGEST LINE "
PRINT "IN YOUR TEXT).  "
PRINT " "
PRINT "warning: presently this program WILL BOMB if"
PRINT "you specify a margin width less than those of the" 
PRINT "longest line to be right justified."

PRINT " "
INPUT "ENTER <Y> OR <N>: ";ANS$
1111 IF ANS$<>"Y" AND ANS$<>"N" THEN \
   INPUT "HUH??? PLEASE ENTER Y OR N: ";ANS$:GOTO 1111 

IF ANS$="N" THEN 2222

102 INPUT "LEFT MARGIN?  "; MLEFT:INPUT "RIGHT MARGIN?  "; MRIGHT
MAX.DOTS = ABS(12* (MRIGHT - MLEFT))
IF MAX.DOTS>1185 THEN \
	GOSUB 99: PRINT "IMPOSSIBLE! MAXIMUM DOTS PER LINE IS 1185 ":\
PRINT "(ABOUT 100 CHARACTERS).  TRY AGAIN": \
	GOSUB 99: GOTO 102

GOTO 3333



REM ********** CALCULATE LENGTH OF LONGEST LINE, IF DESIRED

2222 MAX.DOTS=1
FRONT.OFWORD=1

FOR I=1 TO NUM.LINES
	NUM.CHARS=LEN(THIS.LINE$(I))
	FOR J = 1 TO NUM.CHARS
		CHARACTER$(J)= MID$(THIS.LINE$(I),J,1)
	NEXT J

	NUM.SPACES=0
	BACK.OFWORD=NUM.CHARS: DOTS=0: GOSUB 5000
	IF DOTS>MAX.DOTS THEN MAX.DOTS=DOTS
NEXT I

IF MAX.DOTS>1185 THEN \
	GOSUB 99: PRINT "DARN! DIDN'T WORK. ":\
	PRINT "PLEASE ENTER THE MARGINS MANUALLY.  ":\
	GOSUB 99: GOTO 102


PRINT "MAXIMUM DOTS IN A LINE WILL BE ";MAX.DOTS




REM ********** DEFINE MARKERS- THESE
REM ********** MUST BE IN TEXT ALREADY!!

3333 BEGIN.RJ$="/B/"
END.RJ$="/E/"



SKIP.NEXT$="N"
FIRST=1: FROM.HERE=1

104  BACK$="NO": LAST = NUM.LINES
FIND$=BEGIN.RJ$: WIDE=3: GOSUB 1000
THIS.LINE$(FOUND) = AFTER$
GOSUB 2000

FIRST=NOW.AT+1
IF SKIP.NEXT$="Y" THEN SKIP.NEXT$="N": FIRST=FIRST+1
GOTO 104




REM ********** ********** 
REM ********** SUBROUTINES
REM ********** ********** 




REM ********** 
REM ********** FINDS A STRING IN A VECTOR
REM ********** AND DEFINES STRINGS BEFORE AND AFTER IT 
REM ********** 

1000 FOR AA = FIRST TO LAST
	L=0: LONG=LEN(THIS.LINE$(AA))
	IF WIDE<>0 THEN ONES=1  ELSE ONES=0
	
	HERE=MATCH(FIND$, THIS.LINE$(AA), FROM.HERE)
	IF HERE>0 THEN HERE = HERE+WIDE: FOUND=AA:\
	  L=HERE -WIDE-ONES: R= LONG-L-WIDE:\
  	  AFTER$=RIGHT$(THIS.LINE$(AA),R):\
  	  BEFORE$=LEFT$(THIS.LINE$(AA),L): \
	  RETURN

	IF HERE=0 AND FIND$=BEGIN.RJ$ AND AA<>LAST THEN\
	 PRINT# 1; THIS.LINE$(AA)
NEXT AA

IF THIS.LINE$(LAST)=QUIT.THIS$ THEN GOSUB 3000
IF BACK$="YES" THEN RETURN
GOSUB 99: PRINT "FIND STRING FAILURE.  FIND$=";FIND$: STOP



REM ********** 
REM ********** REFORMS LINE TO BE RIGHT JUSTIFIED
REM ********** SO IT IS AS LONG AS POSSIBLE YET WITHIN MARGINS
REM ********** presently, this can't make lines shorter
REM **********  

2000 FOR I = FOUND TO NUM.LINES
	NOW.AT=I

	BACK$="YES": FIRST=I: LAST=I
	FIND$=END.RJ$: FROM.HERE=1: WIDE=3: GOSUB 1000
	IF HERE<>0 THEN \
		THIS.LINE$(I)=BEFORE$:\
		PRINT# 1; THIS.LINE$(I): RETURN

	NUM.CHARS=LEN(THIS.LINE$(I))	
	IF NUM.CHARS=0 THEN \
	  GOSUB 99: PRINT"HUH?? NO CHARACTERS IN LINE # ";I: GOTO 2009

	FOR J = 1 TO NUM.CHARS
		CHARACTER$(J)= MID$(THIS.LINE$(I),J,1)
	NEXT J



REM ********** REMOVE EXTRANEOUS SPACES AT END OF LINE

	FOR J = 1 TO NUM.CHARS
		IF CHARACTER$(NUM.CHARS)=" " THEN \
		  NUM.CHARS=NUM.CHARS-1  :\
		  THIS.LINE$(NOW.AT)=LEFT$(THIS.LINE$(NOW.AT),NUM.CHARS)\
			ELSE GOTO 2004
	NEXT J


2004    NUM.SPACES=0


REM ********** COUNT UP DOTS IN LINE NOW

        DOTS = 0: FRONT.OFWORD=1: BACK.OFWORD=NUM.CHARS
	GOSUB 5000: DOTSIN.LINE = DOTS

        DIF=MAX.DOTS - DOTSIN.LINE
	
2002	FIRST = I+1: LAST=FIRST: FROM.HERE=1 


REM ********** SEARCH FOR WORD IN NEXT LINE TO FIT ON THIS LINE

	FIND$="-":  WIDE=0: GOSUB 1000: HERE1=HERE
	FIND$=" ":  WIDE=1: GOSUB 1000: 
	IF HERE1<HERE AND HERE1>0 THEN \
	  FIND$="-": WIDE=0: GOSUB 1000
	
	STOPIT=MATCH(END.RJ$,THIS.LINE$(I+1),1)


	SKIP.NEXT$="N"
	IF HERE=0 AND STOPIT=0 THEN GOSUB 4000: GOTO 2009
	IF HERE=0 AND STOPIT<>0 THEN \
		THIS.LINE$(I+1)=NULL$:\
		SKIP.NEXT$="Y":\
		PRINT# 1; THIS.LINE$(I): RETURN
	IF BEFORE$=END.RJ$ THEN \
		THIS.LINE$(I+1)=NULL$:\
		SKIP.NEXT$="Y":\
		PRINT# 1; THIS.LINE$(I): RETURN



	IF L=0 THEN THIS.LINE$(I+1)=AFTER$: GOTO 2002

	IF RIGHT$(THIS.LINE$(I),1)<>"-" THEN BEFORE$=" " +BEFORE$ 
	IF RIGHT$(THIS.LINE$(I),1)="." THEN BEFORE$=" " + BEFORE$ 
	OLD=NUM.CHARS+1
	NEW=NUM.CHARS +LEN(BEFORE$) 
	


REM ********** FIND OUT IF WORD WILL MAKE LINE TOO LONG

	JJJ=0
	FOR J = OLD TO NEW
		JJJ=JJJ+1
		CHARACTER$(J)= MID$(BEFORE$,JJJ,1)
	NEXT J
	DOTS=0: FRONT.OFWORD=OLD: BACK.OFWORD=NEW
	GOSUB 5000

	IF DOTS>DIF THEN GOSUB 4000: GOTO 2009 \
		ELSE THIS.LINE$(I+1)=AFTER$: \
			THIS.LINE$(I)=THIS.LINE$(I) + BEFORE$:\ 
			NUM.CHARS=NEW:\
			DIF = DIF-DOTS 
	IF DIF>13 THEN GOTO 2002  ELSE GOSUB 4000

2009 NEXT I




REM ********** 
REM ********** ADD ONE OR MORE DOT SPACES TO EACH
REM ********** EXISTING (7 DOT) SPACES TO RIGHT JUSTIFY LINE
REM ********** 

4000 SPACE=1

FOR FILL = 1 TO DIF
	IF SPACE>NUM.SPACES THEN SPACE=1

	IF SPACE<6 AND LEFT$(THIS.LINE$(NOW.AT),5)="     " \
	   THEN SPACE=6
	   

	CHARACTER$(HERES.ASPACE(SPACE)) = CHARACTER$(HERES.ASPACE(SPACE)) \
		+ "|"

	SPACE =SPACE+1
NEXT FILL	

NUM.PLUS=0
THIS.LINE$(NOW.AT)=CHARACTER$(1)



REM ********** REDEFINE LINE WITH THESE NEW LONGER
REM ********** SPACES AND THEN STORE IT.
REM ********** IF TOO MANY CHARACTERS FOR ONE CBASIC 
REM ********** STRING, STORE IN EXTRA$ TOO.

ANOTHER$="N"
FOR QQ=2 TO NUM.CHARS
	
	IF ANOTHER$="N" THEN\
	  HOW.LONG=LEN(CHARACTER$(QQ)) + LEN(THIS.LINE$(NOW.AT)) \
	  ELSE HOW.LONG=LEN(CHARACTER$(QQ)) + LEN(EXTRA$(NUM.PLUS)) 

	IF HOW.LONG>250 THEN\
		NUM.PLUS=NUM.PLUS+1:\
		EXTRA$(NUM.PLUS)=FLAG$:\
 		ANOTHER$="Y"

	IF ANOTHER$="N" THEN\
          THIS.LINE$(NOW.AT) = THIS.LINE$(NOW.AT) + CHARACTER$(QQ) \
	  ELSE EXTRA$(NUM.PLUS)=EXTRA$(NUM.PLUS) + CHARACTER$(QQ)
	  
NEXT QQ

PRINT# 1; THIS.LINE$(NOW.AT)
IF ANOTHER$="Y" THEN \
	FOR ZZ= 1 TO NUM.PLUS:\
		PRINT# 1; EXTRA$(ZZ):\
	NEXT ZZ

RETURN





REM ********** 
REM ********** COUNT UP DOTS IN LINE
REM ********** OR IN A WORD AND IDENTIFY LOCATIONS
REM ********** OF EXISTING (7 DOT) SPACES.
REM ********** 

5000 FOR DUMMYJ=FRONT.OFWORD TO BACK.OFWORD
     IF MATCH(CHARACTER$(DUMMYJ),"j",1)<>0 THEN \
       DOTS = DOTS + 6: GOTO 5001
     IF MATCH(CHARACTER$(DUMMYJ)," ",1)<>0 THEN \
       NUM.SPACES=NUM.SPACES+1:HERES.ASPACE(NUM.SPACES)=DUMMYJ:\
       DOTS = DOTS + 7: GOTO 5001

     IF MATCH(CHARACTER$(DUMMYJ),DOTTY8$,1)<>0 THEN \
       DOTS = DOTS + 8: GOTO 5001
     IF MATCH(CHARACTER$(DUMMYJ),DOTTY10$,1)<>0 THEN \
       DOTS = DOTS + 10: GOTO 5001
     IF MATCH(CHARACTER$(DUMMYJ),DOTTY7$,1)<>0 THEN \
       DOTS = DOTS + 7: GOTO 5001
     IF MATCH(CHARACTER$(DUMMYJ),DOTTY18$,1)<>0 THEN \
       DOTS = DOTS + 18: GOTO 5001
     IF MATCH(CHARACTER$(DUMMYJ),DOTTY15$,1)<>0 THEN \
       DOTS = DOTS + 15: GOTO 5001
     IF MATCH(CHARACTER$(DUMMYJ),DOTTY14$,1)<>0 THEN \
       DOTS = DOTS + 14: GOTO 5001
     IF MATCH(CHARACTER$(DUMMYJ),DOTTY16$,1)<>0 THEN \
       DOTS = DOTS + 16: GOTO 5001

     IF MATCH(CHARACTER$(DUMMYJ),DOTTY12$,1)<>0 THEN \
       DOTS=DOTS+12: GOTO 5001

5001 NEXT DUMMYJ

RETURN



REM ********** 
REM ********** END PROGRAM
REM ********** 

3000  GOSUB 99: PRINT "TEXT HAS BEEN RIGHT JUSTIFIED."


PRINT "TEXT HAS BEEN SAVED IN A FILE CALLED "; FILENAME$

PRINT "HAVE A GOOD DAY."
STOP


REM ********** 
REM ********** PRINT SPACING
REM ********** 

99 PRINT " ":PRINT " ":PRINT " ": RETURN