@PAGEFOOTING()@CENTER[THIS IS PAGENOS.MSS
A COOKBOOK FOR ELIMINATING THE PAGE NUMBER
ON PAGE ONE (ONLY) OF PERFECT WRITER DOCUMENTS
ARNOLD JOYAL - NOVEMBER 1986 - COLAVKUG]

I frequently write letters and other documents where I do not
want to have the page number appear on page one of the document. 
I do want regular page numbers on subsequent pages.  I have been
looking for a graceful method for doing this in Perfect Writer. 
Using the little bottle of white stuff to erase the "- 1 -"
seemed crude and inelegant, as did eliminating all page numbers
and then cranking the printed pages back into a printer or
typewriter for numbering.

An article in the Nov-Dec issue of @UX{SCROLL}, the word
processing newsletter, put me on the right track.  I took their
idea for page numbers at the top of the page and adapted it to
the bottom of the page.  How easy!

Start off your document (before any text) with the commands
@VERBATIM{
     @@PAGEFOOTING() 

     @@SET(PAGE=1)@@PAGEFOOTING(CENTER="- @@REF[PAGE] -")}

Notice that there is a blank line between the two commands. You
can, of course, customize the second command to put page numbers
left or right, eliminate the dashes, or put page numbers at the
top of the page with an @@PAGEHEADING command.  If you use the
same page number format all the time, you could have the entire
command on a macro, such as is provided by Xtrakey, Smartkey, or
a similar program. 
 Writer. 
Using the little bottle of white stuff to erase the "- 1 -"
seemed cru