* ANYDATE.CMD  Call up datebook for any day/week
* By A.C. Scott; started 6/20/84
* CALLED FROM: DATEBOOK, THISWEEK, SEARCH
* CALLS:
ERASE
SET TALK OFF
SET COLON OFF
?
?
? '                 Enter date you wish to view below'
?
?
? '                  You can then call up that week'
?
?
?
?
?
* Get date
STORE '  ' TO MO
STORE '  ' TO DA
@ 12,5 SAY 'Enter Date (MO/DA): ' GET MO PICTURE '99'
@ 12,27 SAY '/' GET DA PICTURE '99'
READ
ERASE
* Put date into '99/99' format, adding leading zeros if not entered that way
IF VAL(MO) < 10
STORE '0' + STR(VAL(MO),1,0) TO XMO
ELSE
STORE MO TO XMO
ENDIF
IF VAL(DA) < 10
STORE '0' + STR(VAL(DA),1,0) TO XDA
ELSE
STORE DA TO XDA
ENDIF
STORE XMO + '/' + XDA TO ASKDT
* Use index & Find to position on requested date
USE YEAR INDEX DATE
FIND &ASKDT
* spell out day of week (2 letter abbrev. in database)
DO CASE
CASE DAYNAME='MO'
STORE 'MONDAY' TO DN
CASE DAYNAME='TU'
STORE 'TUESDAY' TO DN
CASE DAYNAME='WE'
STORE 'WEDNESDAY' TO DN
CASE DAYNAME='TH'
STORE 'THURSDAY' TO DN
CASE DAYNAME='FR'
STORE 'FRIDAY' TO DN
CASE DAYNAME='SA'
STORE 'SATURDAY' TO DN
OTHERWISE
STORE 'SUNDAY' TO DN
ENDCASE
* show current date at top of screen
STORE TRIM(DN) + ', ' + TRIM(MONAME) + ' ' + STR(DAYNUM,2,0) TO XYZ
@ 1,15 SAY 'Date Requested Is ' + XYZ
* flag is set to '*', if any entries
IF FLAG=' '
@ 8,20 SAY '***  NO DATEBOOK ENTRIES ***'
ELSE
* display datebook entries
@ 3,20 SAY '+++  ON THE DOCKET +++'
@ 5,5 SAY 'TIME'
@ 5,30 SAY 'ITEM'
@ 6,5 SAY '****'
@ 6,30 SAY '****'
@ 9,2 SAY TIME1
@ 9,8 SAY AP1
@ 9,15 SAY NOTE1
@ 12,2 SAY TIME2
@ 12,8 SAY AP2
@ 12,15 SAY NOTE2
@ 15,2 SAY TIME3
@ 15,8 SAY AP3
@ 15,15 SAY NOTE3
@ 18,2 SAY TIME4
@ 18,8 SAY AP4
@ 18,15 SAY NOTE4
ENDIF
* Show entry for holiday, only if there is one; bracket holiday in solid
* square graphics char.
IF HOLIDAY=' '
@ 21,10
ELSE
@ 21,10 SAY "HOLIDAY!  "+CHR(31)+' '+TRIM(HOLIDAY)+' '+CHR(31)
ENDIF
* Option calls to other modules or main menu
@ 23,2 SAY 'OPTIONS:  P = Print Day; W = View Week; any other = Main Menu'
SET CONSOLE OFF
WAIT TO SELEC1
SET CONSOLE ON
DO CASE
* View week option
CASE !(SELEC1) = 'W'
* Trap for last 2 days of year; week display bombs for those days
IF ASKDT = '12/30' .OR. ASKDT = '12/31'
ERASE
@ 10,10 SAY 'Last 2 days of 1984; option to view week not available.'
@ 12,10 SAY 'Hit any key to return to Main Menu.'
SET CONSOLE OFF
WAIT
SET CONSOLE ON
RETURN
ENDIF
* Otherwise, initialize to view week by finding which day of week you're at
ERASE
DO CASE
 CASE DAYNAME='SU'
 STORE 0 TO DANO
 CASE DAYNAME='MO'
 STORE 1 TO DANO
 CASE DAYNAME='TU'
 STORE 2 TO DANO
 CASE DAYNAME='WE'
 STORE 3 TO DANO
 CASE DAYNAME='TH'
 STORE 4 TO DANO
 CASE DAYNAME='FR'
 STORE 5 TO DANO
 OTHERWISE
 STORE 6 TO DANO
ENDCASE
* position pointer on sunday of week you're in
SKIP -DANO
STORE # TO SUNNO
STORE TRIM(MONAME) + ' ' + STR(DAYNUM,2,0) TO WKOF
* Display Sunday date for week at top of screen, days of week across top
@ 1,20 SAY 'DATEBOOK FOR WEEK OF ' + WKOF
@ 3,5 SAY 'SUN'
@ 3,16 SAY 'MON'
@ 3,27 SAY 'TUE'
@ 3,38 SAY 'WED'
@ 3,49 SAY 'THU'
@ 3,60 SAY 'FRI'
@ 3,71 SAY 'SAT'
* Display dates (MO/DA) across screen centered under days of week
STORE 4 TO Y
DO WHILE # < SUNNO+7
* Put all dates in '99/99' format with leading zeros
DO CASE
  CASE MONUM<10 .AND. DAYNUM<10
STORE '0' + STR(MONUM,1,0) + '/' + '0' + STR(DAYNUM,1,0) TO ZIG
  CASE MONUM<10 .AND. DAYNUM>9
STORE '0' + STR(MONUM,1,0) + '/' + STR(DAYNUM,2,0) TO ZIG
  CASE MONUM>9 .AND. DAYNUM<10
STORE STR(MONUM,2,0) + '/' + '0' + STR(DAYNUM,1,0) TO ZIG
  OTHERWISE
STORE STR(MONUM,2,0) + '/' + STR(DAYNUM,2,0) TO ZIG
ENDCASE
 @ 4,Y SAY ZIG
SKIP
STORE Y+11 TO Y
ENDDO
* Message, indicating only 2 entries shown, CHR(127) flag if more than 2
@ 6,1 SAY 'SHORTFORM SUMMARY (If '
@ 6,20 SAY CHR(127)
@ 6,21 SAY ' flag at far right, more than two entries, view date)'
* Start at Sunday, go down screen with Day & entries
GOTO SUNNO
STORE 8 TO LN
DO WHILE # < SUNNO+7
DO CASE
 CASE FLAG = ' '
@ LN,1 SAY DAYNAME
@ LN,17 SAY ' *** NO ENTRIES ***'
@ LN+1,17
 CASE FLAG = '*' .AND. NOTE3 = ' '
@ LN,1 SAY DAYNAME
@ LN,6 SAY TIME1
@ LN,12 SAY AP1
@ LN,17 SAY NOTE1
@ LN+1,17 SAY NOTE2
* Shows CHR(127) flag if Note3 not empty
 CASE FLAG='*' .AND. NOTE3 # ' '
@ LN,1 SAY DAYNAME
@ LN,6 SAY TIME1
@ LN,12 SAY AP1
@ LN,17 SAY NOTE1
@ LN+1,17 SAY NOTE2
@ LN+1,78 SAY CHR(127)
ENDCASE
SKIP
STORE LN+2 TO LN
ENDDO
* Return to main menu
@ 23,2 SAY 'Hit any key to return to Main Menu'
SET CONSOLE OFF
WAIT
SET CONSOLE ON
ERASE
RELEASE ALL EXCEPT MDT
RETURN
* Print option for selected day's full datebook entry
CASE !(SELEC1) = 'P'
DO TODAYP
RELEASE ALL EXCEPT MDT
RETURN
OTHERWISE
* Original option to return to menu (DATEBOOK)
ERASE
RELEASE ALL EXCEPT MDT
RETURN
ENDCASE
* EOF anydate.cmd
ate.cmd
21,10 SAY "HOLIDAY!  "+CHR(31)+' '+TRIM(HOLIDAY)+' '+CHR(31)
ENDIF
* Option calls to other modules or main menu
@ 23,2 SAY 'O