* THISWEEK.CMD  gives weeks worth of datebook displays
* By A.C. Scott  started 6/19/84
* CALLED FROM: DATEBOOK
* CALLS:
ERASE
SET TALK OFF
* Get today's date
STORE DATE() TO MDT
* Trap last 2 days of year & exit (program bombs on those days)
IF $(MDT,1,5) = '12/30' .OR. $(MDT,1,5) = '12/31'
@ 10,10 SAY 'Last 2 days of year.  Option to view week not available.'
@ 12,10 SAY 'Hit any key to return to Main Menu.'
SET CONSOLE OFF
WAIT
SET CONSOLE ON
RETURN
ENDIF
* use YEAR, indexed on date
USE YEAR INDEX DATE
FIND &MDT
* set counter for this day of week
DO CASE
 CASE DAYNAME='SU'
 STORE 0 TO DANO
 CASE DAYNAME='MO'
 STORE 1 TO DANO
 CASE DAYNAME='TU'
 STORE 2 TO DANO
 CASE DAYNAME='WE'
 STORE 3 TO DANO
 CASE DAYNAME='TH'
 STORE 4 TO DANO
 CASE DAYNAME='FR'
 STORE 5 TO DANO
 OTHERWISE
 STORE 6 TO DANO
ENDCASE
* position pointer on sunday of week you're in
SKIP -DANO
STORE # TO SUNNO
* write days across screen
STORE TRIM(MONAME) + ' ' + STR(DAYNUM,2,0) TO WKOF
@ 1,20 SAY 'DATEBOOK FOR WEEK OF ' + WKOF
@ 3,5 SAY 'SUN'
@ 3,16 SAY 'MON'
@ 3,27 SAY 'TUE'
@ 3,38 SAY 'WED'
@ 3,49 SAY 'THU'
@ 3,60 SAY 'FRI'
@ 3,71 SAY 'SAT'
* set counter for column
STORE 4 TO Y
* get date for ea. day & write across screen
DO WHILE # < SUNNO+7
* Put all dates in '99/99' format with leading zeros
DO CASE
  CASE MONUM<10 .AND. DAYNUM<10
STORE '0' + STR(MONUM,1,0) + '/' + '0' + STR(DAYNUM,1,0) TO ZIG
  CASE MONUM<10 .AND. DAYNUM>9
STORE '0' + STR(MONUM,1,0) + '/' + STR(DAYNUM,2,0) TO ZIG
  CASE MONUM>9 .AND. DAYNUM<10
STORE STR(MONUM,2,0) + '/' + '0' + STR(DAYNUM,1,0) TO ZIG
  OTHERWISE
STORE STR(MONUM,2,0) + '/' + STR(DAYNUM,2,0) TO ZIG
ENDCASE
 @ 4,Y SAY ZIG
SKIP
STORE Y+11 TO Y
ENDDO
* heading for entries
 @ 6,1 SAY 'SHORTFORM SUMMARY (If '
@ 6,20 SAY CHR(127)
@ 6,21 SAY ' flag at far right, more than two entries, view date)'
* position on Sunday
GOTO SUNNO
* set line counter
STORE 8 TO LN
DO WHILE # < SUNNO+7
* write 1st 2 entries down screen for ea. day, 2nd line blank if no note2
DO CASE
 CASE FLAG = ' '
@ LN,1 SAY DAYNAME
@ LN,17 SAY ' *** NO ENTRIES ***'
@ LN+1,17
 CASE FLAG = '*' .AND. NOTE3 = ' '
@ LN,1 SAY DAYNAME
@ LN,6 SAY TIME1
@ LN,12 SAY AP1
@ LN,17 SAY NOTE1
@ LN+1,17 SAY NOTE2
 CASE FLAG='*' .AND. NOTE3 # ' '
@ LN,1 SAY DAYNAME
@ LN,6 SAY TIME1
@ LN,12 SAY AP1
@ LN,17 SAY NOTE1
@ LN+1,17 SAY NOTE2
* put marker flag in col. 78 if more than 2 entries
@ LN+1,78 SAY CHR(127)
ENDCASE
SKIP
STORE LN+2 TO LN
ENDDO
* set options
@ 23,1 SAY;
  'OPTIONS: N = view Next week; D = view any Date; any other = Main Menu'
SET CONSOLE OFF
WAIT TO ACT1
SET CONSOLE ON
DO CASE
* option to view any day/wk
 CASE !(ACT1)='D'
RELEASE ALL EXCEPT MDT
ERASE
DO ANYDATE
RETURN
* option to view next wk.
 CASE !(ACT1)='N'
RELEASE DANO, Y, LN, WKOF, ZIG, ZAG
* repeat shortform summary as above
* set pointer to next sunday
STORE SUNNO+7 TO SUNNO
GOTO SUNNO
ERASE
* Trap if next wk is last 2 days of year; exits
IF SUNNO = 365
@ 10,5 SAY 'Next Week -- Last 2 days of year.  Option to view week not available.'
@ 12,10 SAY 'Hit any key to return to Main Menu.'
SET CONSOLE OFF
WAIT
SET CONSOLE ON
RETURN
ENDIF
@ 1,2 SAY '**NEXT WEEK**'
STORE TRIM(MONAME) + ' ' + STR(DAYNUM,2,0) TO WKOF
@ 1,20 SAY 'DATEBOOK FOR WEEK OF ' + WKOF
@ 3,5 SAY 'SUN'
@ 3,16 SAY 'MON'
@ 3,27 SAY 'TUE'
@ 3,38 SAY 'WED'
@ 3,49 SAY 'THU'
@ 3,60 SAY 'FRI'
@ 3,71 SAY 'SAT'
STORE 4 TO Y
DO WHILE # < SUNNO+7
* Put all dates in '99/99' format with leading zeros
DO CASE
  CASE MONUM<10 .AND. DAYNUM<10
STORE '0' + STR(MONUM,1,0) + '/' + '0' + STR(DAYNUM,1,0) TO ZIG
  CASE MONUM<10 .AND. DAYNUM>9
STORE '0' + STR(MONUM,1,0) + '/' + STR(DAYNUM,2,0) TO ZIG
  CASE MONUM>9 .AND. DAYNUM<10
STORE STR(MONUM,2,0) + '/' + '0' + STR(DAYNUM,1,0) TO ZIG
  OTHERWISE
STORE STR(MONUM,2,0) + '/' + STR(DAYNUM,2,0) TO ZIG
ENDCASE
 @ 4,Y SAY ZIG
SKIP
STORE Y+11 TO Y
ENDDO
@ 6,1 SAY 'SHORTFORM SUMMARY (If '
@ 6,20 SAY CHR(127)
@ 6,21 SAY ' flag at far right, more than two entries, view date)'
GOTO SUNNO
STORE 8 TO LN
DO WHILE # < SUNNO+7
DO CASE
	CASE FLAG = ' '
@ LN,1 SAY DAYNAME
@ LN,17 SAY ' *** NO ENTRIES ***'
@ LN+1,17
	CASE FLAG = '*' .AND. NOTE3 = ' '
@ LN,1 SAY DAYNAME
@ LN,6 SAY TIME1
@ LN,12 SAY AP1
@ LN,17 SAY NOTE1
@ LN+1,17 SAY NOTE2
	CASE FLAG='*' .AND. NOTE3 # ' '
@ LN,1 SAY DAYNAME
@ LN,6 SAY TIME1
@ LN,12 SAY AP1
@ LN,17 SAY NOTE1
@ LN+1,17 SAY NOTE2
@ LN+1,78 SAY CHR(127)
ENDCASE
SKIP
STORE LN+2 TO LN
ENDDO
* option to view any date or return to main menu
@ 23,2 SAY 'OPTIONS: D = view any Date; any other = Main Menu'
SET CONSOLE OFF
WAIT TO ACT2
SET CONSOLE ON
* anydate option
IF !(ACT2) = 'D'
	RELEASE ALL EXCEPT MDT
	ERASE
	DO ANYDATE
	RETURN
* Exit option from Next week
ELSE
ERASE
RELEASE ALL EXCEPT MDT
RETURN
ENDIF
* exit option from This week
OTHERWISE
ERASE
RELEASE ALL EXCEPT MDT
RETURN
ENDCASE
* EOF THISWEEK.CMD
