; TXT  v4.2  -	MESSAGE UTILITY PROGRAM 	07/14/84
;
;		Terry Hazen
;
; TXT42.COMimethoocreatininstan.CO͠file
; thawilprinoutextuamessagesThprintouo
;thmessagmabinterceptewit^àan^ andwit
; ESCAPŠkey
;
; ThfilTXT42.COMibasicallshorprograthasit
;athheaotexfilthaicreateiWordstar'
;NON-documenmode
;
; Thprograpermitthusothtilde characte
; ithtex tmakthe display  pauseFormatted screen 
; pages may be created by adding sufficienCRLF'tthe 
; text to create the desiredscreen pag formats. 
;
; TXT42.COM has been renamed TEXTCOM.LIB in this .LBR.  It  
; never runs on its own, so can be called by any convenient
; name to avoid confusing it with a working .COM file.
;
; Usthfollowinprocedurtseutexfil
; FILENAME.COM
;
;1LoaWӠangintnon-documenmode
;2UsFILENAME.CO͠fothfiltedit
;3WӠwilresponwitNEנFILE
;4Us^KҠtreaintmemorthfilTXT401.COM
;5Use ^KR to read into memore yourtexfile 
;         betweeth堿anthfollowin^@
;6Savthfilantheruia.CO͠file
;
; AL̠characteru t th fina ^ wil print I i
; VER importantha th fina ^ b i plac a th en o
; th file otherwis strang thingwil b printe unti
; nuli encountered.  A null (^@) has been included at
; the end of the file so that text may be inserted without
; worrying about how to create a null on your terminal.
; Note that the ^@ is a null, NOT a "^" character plus a
; "@" character.
;
; For more information on its use, see TXT42.DOC or run
; DOC.COM, an example of a finished .COM file.
;
;***********************************************************
;
; 07/14/84	Added a line of code to strip hi-order bits
;   v4.2	from text to make text creation with WS Doc-
;		ument mode easier.  Now reads tildes even if
;		created in Document mode.  Added abort with
;		<^X> to previous abort characters.
;				- Terry Hazen
;		
; 07/12/84	Program and documentation re-written.  
;   v4.1	'Hit <RETURN>' was replaced with '[more]' to
;		be consistant with other programs.  Now  
;		aborts with <^C> or <ESC>.   <^S> pauses the 
;		text display.
;				- Terry Hazen
;
; 06/15/84	Revised file and added <Ctrl-S>, abort char-
;   v4.0	acter etc.  Named it TXT40.ASM to get a jump
;		on the version numbers, as this version is
;		based on my version 2.5 and incorporated Bob
;		Schultz direct I/O calls dated 01/17/84 and
;		Walt Wheeler, Justus Addiss's idea of the 
;		tilde character (this is a neat idea) from
;		their version NTXT3.ASM dated 06/12/84, 
;		allowing the creator of a file to implement
;		paging by inserting a tilde (~) in the 
;		source text file, to PAUSE until the reader
;		strikes a key.  Suggest including a tilde
;		not less often than every 22nd line.
;				- Harry Kaemmerer
; 
; 01/01/84	8080 version N-TXT.COM message utility.
;				- Harry Kaemmerer
;				  CP/M NET EAST
;				  (201) 249-0691
;
; 		Original Z80 TXT.COM version
;				- Simon Ewins
;				  e-mx rcp/m
;				  (416) 484-9663
;
;***********************************************************
;
;
; ASCII CHARACTERS
CR:	EQU	0DH		;carriage return
LF:	EQU	0AH		;line feed
CNTRLC:	EQU	03H		;control C
CNTRLS:	EQU	13H		;control S
CNTRLX:	EQU	18H		;control X
EOF:	EQU	1AH		;end of file marker
ESC:	EQU	1BH		;escape character
TILDE:	EQU	7EH		;tilde character
;
; CP/M EQUATES
BDOS:	EQU	5		;bdos entry point
DIRIO:	EQU	6		;direct console I/O
;
;***********************************************************
;							   ;
;		PROGRAM STARTS HERE			   ;
;							   ;
;***********************************************************
;
;
	ORG	100H		;
;
START:	
	LXI	H,BUFFER	;point to text
;
LOOP:	
	PUSH	H		;save pointer
	MOV	A,M		;get character
	CPI	0		;at end?
	JZ	EXIT		;yes, so quit
	ANI	7FH		;strip hi-order bit
	CPI	TILDE		;is it page character?
	JZ	PAGING		;yes, then pause
	MOV	E,A		;move character to e
	MVI	C,DIRIO		;console out
	CALL	BDOS		;bdos
	CALL	CONIN		;check for key pressed
	JZ	LOOP2		;if no key then continue
	CPI	CNTRLS		;is it ^S?
	JNZ	CHECK		;if not, check for ESC or ^C
;
LOOP1:	
	CALL	CONIN		;check for key pressed
	JZ	LOOP1		;loop until key pressed
;
CHECK:	
	CPI	ESC		;is it an ESC?
	JZ	EXIT		;if so, exit
	CPI	CNTRLC		;is it a ^C?
	JZ	EXIT		;if so, exit
	CPI	CNTRLX		;is it a ^X?
	JZ	EXIT		;yes, quit
;
LOOP2:	
	POP	H		;get pointer
	INX	H		;and bump to next character
	JMP	LOOP		;go on doing it
;
PAGING:	
	PUSH	H		;save pointer
	LXI	H,MESS1		;get the message
	MOV	A,M		;get first character
;
LOOP3:	
	MOV	E,A		;need it in E for bdos call
	MVI	C,DIRIO		;set bdos function call
	PUSH	H		;save pointer
	CALL	BDOS		;ok, send the character
	POP	H		;return pointer
	INX	H		;set up for next character
	MOV	A,M		;get next character
	CPI	0		;is it the end?
	JNZ	LOOP3		;nope, loop
	POP	H		;return pointer
	JMP	LOOP1		;done with message, so pause
;
EXIT:	
	POP	H		;clean up the stack
				;do a conin before exit
CONIN:	MVI	E,0FFH		;direct input
	MVI	C,DIRIO		;
	CALL	BDOS		;
	ORA	A		;set flags
	RET			;
;
MESS1:	DB	'[more] ',0	;paging message
;
	DB	CR,LF,'Insert your text between'	
	DB	' the "?" and the "^@":',CR,LF	
	DB	'?',CR,LF	;start of buffer marker
;-----------------------------------------------------------
; Message space starts here, and is as large as your TPA 
;  - 512 bytes
;-----------------------------------------------------------
BUFFER:
	DB	CR,LF		;add blank line to make 
;				insertion easier
	DB	0,CR,LF,EOF	;force a NULL and an EOF
;				;marker to keep the Wordstar
	END	START		;clean

