10 '---------> IMD.BAS <-------------------------
20 '           Rev. A, 24 May '84
30 '           by N6TX
40 '  COPYRIGHT (C) 1984 MICROCOMM
50 ' 
60 '  Determines Spurious-Free Dynamic Range from
70 '  Spectrum Analyzer Two-Tone IMD Measurements
80 '
90 '---------------------------------------------
100 CLR$ = CHR$(26) ' Defines Clear-Screen String
110 PRINT CLR$
120 PRINT "DO YOU WISH OUTPUT ROUTED TO:"
130 PRINT
140 PRINT "                  PRINTER (P)"
150 INPUT "            or    SCREEN  (S)";PR$
160 IF PR$="P" OR PR$="p" OR PR$="S" OR PR$="s" GOTO 200
170 PRINT CLR$
180 PRINT "YOU MUST RESPOND WITH 'P' OR 'S'" : PRINT
190 GOTO 120
200 '--------------------------------------------
210 PRINT CLR$
220 PRINT "TONES -->         |  |"
230 PRINT "                  |  |"
240 PRINT "                  |  |"
250 PRINT "                  |  |"
260 PRINT " IMD  -->      |  |  |  |"
270 PRINT "               |  |  |  |"
280 PRINT "            ----------------" : PRINT
290 PRINT "FOR TWO-TONE OUTPUT SPECTRUM AS INDICATED ABOVE,"
300 PRINT
310 INPUT "ENTER Two-Tone Output Amplitude, in dBm ",TONES
320 INPUT "ENTER Third-Order IMD Amplitude, in dBm ",IMD
330 INPUT "ENTER System Gain,               in dB  ",GAIN
340 INPUT "ENTER System Noise Figure,       in dB  ",NF
350 INPUT "ENTER System Bandwidth,          in kHz ",BW
360 I3=TONES + ((TONES - IMD) / 2)
370 MDS = NF - 144 + 10*(LOG(BW)/LOG(10))
380 INMAX = ((2/3)*(I3-GAIN))+(MDS/3)
390 RANGE = INMAX - MDS
400 '--------------------------------------------
410 PRINT CLR$
420 PRINT "INTERMODULATION ANALYSIS BY MICROCOMM"
430 PRINT : PRINT
440 PRINT USING "####.# dBm -->        |  |   ";TONES
450 PRINT       "                      |  |   "
460 PRINT       "                      |  |   "
470 PRINT       "                      |  |   "
480 PRINT USING "####.# dBm -->     |  |  |  |";IMD
490 PRINT       "                   |  |  |  |"
500 PRINT       "                ----------------"
510 PRINT : PRINT
520 PRINT USING "SYSTEM GAIN          = ####.# dB";GAIN
530 PRINT USING "SYSTEM NOISE FIGURE  = ####.# dB";NF
540 PRINT USING "SYSTEM BANDWIDTH     = ####.# kHz";BW
550 PRINT
560 PRINT USING "OUTPUT THIRD ORDER INTERCEPT POINT = ####.# dBm";I3
570 PRINT USING "MINIMUM DISCERNIBLE INPUT SIGNAL   = ####.# dBm";MDS
580 PRINT USING "MAXIMUM SPURIOUS-FREE INPUT SIGNAL = ####.# dBm";INMAX
590 PRINT USING "SPURIOUS-FREE DYNAMIC RANGE        = ####.# dB";RANGE
600 '--------------------------------------------
610 IF PR$="S" OR PR$="s" THEN GOTO 800
620 LPRINT "INTERMODULATION ANALYSIS BY MICROCOMM"
630 LPRINT : LPRINT
640 LPRINT USING "####.# dBm -->         |  |   "; TONES
650 LPRINT       "                       |  |   "
660 LPRINT       "                       |  |   "
670 LPRINT       "                       |  |   "
680 LPRINT USING "####.# dBm -->      |  |  |  |"; IMD
690 LPRINT       "                    |  |  |  |"
700 LPRINT       "                 -----------------"
710 LPRINT : LPRINT
720 LPRINT USING "SYSTEM GAIN          = ####.# dB";GAIN
730 LPRINT USING "SYSTEM NOISE FIGURE  = ####.# dB";NF
740 LPRINT USING "SYSTEM BANDWIDTH     = ####.# kHz";BW
750 LPRINT
760 LPRINT USING "     OUTPUT THIRD ORDER INTERCEPT POINT = ####.# dBm"; I3
770 LPRINT USING "     MINIMUM DISCERNIBLE INPUT SIGNAL   = ####.# dBm";MDS
780 LPRINT USING "     MAXIMUM SPURIOUS-FREE INPUT SIGNAL = ####.# dBm";INMAX
790 LPRINT USING "     SPURIOUS-FREE DYNAMIC RANGE        = ####.# dB";RANGE
792 LPRINT
794 LPRINT
796 LPRINT
798 LPRINT
800 '---------------------------------------------
810 PRINT : PRINT
820 INPUT "TYPE <return> TO CONTINUE, 'Q' TO QUIT ",D$
830 IF D$ = "Q" OR D$ = "q" THEN GOTO 850
840 GOTO 100
850 END
INT
820 INPUT "TYPE <return> TO CONTINUE, 'Q' TO QUIT ",