10 'NOTE.BAS written by R. S. Stein, 4-21-86.  Revised 5-27-86.
20 PRINT CHR$(26)
30 PRINT "NOTE.BAS records payments against an amortized note and calculates
40 PRINT "the amount allocated to interest and principal for each payment and
50 PRINT "the present value of the note.
51 'Lines 52-59 check for erroneous presence of TMP data file on disk
52 TMPFLAG%=0
54 ON ERROR GOTO 59
56 OPEN "I",#1,"TMP"
57 TMPFLAG%=1
58 CLOSE #1 : GOTO 60
59 RESUME 60
60 ON ERROR GOTO 530	'Initialize data file or correct data file name
70 OPEN "I",#1,"NOTE.DAT"
80 OPEN "O",#2,"TMP"
90 INPUT #1,INTRATE
100 WRITE #2,INTRATE
110 IF EOF(1) THEN 150
120 INPUT #1,DATE$,PMT$,PERINT$,AMORT$,PV$,TOTINT$
130 WRITE #2,DATE$,PMT$,PERINT$,AMORT$,PV$,TOTINT$
140 GOTO 110
150 CLOSE #1
160 KILL"NOTE.DAT"
170 PRINT : PRINT
172 PRINT "The program allows you to review the record of previous payments.
174 INPUT "Do you want to enter new Payment or review Record? (P/R) ";C$
176 IF C$<>"P" AND C$<>"p" THEN RUN 300
178 PRINT : PRINT 
180 INPUT "DATE OF PAYMENT (MM/DD/YY) ";DATE$
190 INPUT "AMOUNT OF PAYMENT          ";PMT : PMT$=STR$(PMT)
200 PRINT : INPUT "ANY CHANGES TO THE ABOVE? (Y/N) ";C$
210 IF C$="Y" OR C$="y" THEN PRINT : GOTO 180
220 PV#=VAL(PV$) : TOTINT#=VAL(TOTINT$)
230 PERINT=PV#*INTRATE
240 AMORT=PMT-PERINT : AMORT$=STR$(AMORT)
250 PV#=PV#-AMORT : PV$=STR$(PV#)
260 IF PERINT>=PMT THEN PERINT=PMT
270 PERINT$=STR$(PERINT)
280 TOTINT#=TOTINT#+PERINT : TOTINT$=STR$(TOTINT#)
290 WRITE #2,DATE$,PMT$,PERINT$,AMORT$,PV$,TOTINT$
300 CLOSE #2
310 NAME "TMP" AS "NOTE.DAT"
320 PRINT CHR$(26)
330 OPEN "I",#1,"NOTE.DAT"
340 FLAG%=0
350 INPUT #1,INTRATE
360 IF EOF(1) THEN 500
370 FLAG%=FLAG%+1
380 INPUT #1,DATE$,PMT$,PERINT$,AMORT$,PV$,TOTINT$
390 IF FLAG%=3 THEN PRINT 
400 IF FLAG%<3 THEN PRINT DATE$,PMT$,PERINT$,AMORT$,PV$;TAB(70);TOTINT$ ELSE 420
410 GOTO 360
420 PMT=VAL(PMT$) : PERINT=VAL(PERINT$) : AMORT=VAL(AMORT$) : PV#=VAL(PV$)
430 TOTINT#=VAL(TOTINT$)
440 PRINT DATE$;TAB(13);USING"#,###.##";PMT;
450 PRINT TAB(27);USING"#,###.##";PERINT;  
460 PRINT TAB(41);USING"#,###.##";AMORT;
470 PRINT TAB(56);USING"###,###.##";PV#;
480 PRINT TAB(70);USING"###,###.##";TOTINT#
490 GOTO 360
500 CLOSE
502 PRINT : PRINT
504 INPUT "Do you want a print-out of this record? (Y/N) ";PRT$
505 IF PRT$<>"Y" AND PRT$<>"y" THEN 510
506 PRINT : INPUT "Press <CR> when your printer is ready ",CR$
508 GOSUB 800
510 END
520 '------------------------------------------------------------------------
530 'Correct for error in data file name if Ctrl-C has been used
532 IF TMPFLAG%=1 THEN NAME "TMP" AS "NOTE.DAT" ELSE 535
533 TMPFLAG%=0
534 RESUME 70
535 'Correct for empty NOTE.DAT file if Ctrl-C has been used
536 IF ERL=90 OR ERL=100 THEN CLOSE ELSE 540
537 KILL "TMP" : KILL "NOTE.DAT"
538 RESUME 70
539 'Initialize data file
540 PRINT : PRINT STRING$(75,"=")
550 PRINT "The following routine is used only to initialize the sequential data file 
560 PRINT "NOTE.DAT when this program is first used or when the data file is deleted.
570 PRINT 
580 IF ERR=53 AND ERL=70 THEN OPEN "O",#1,"NOTE.DAT" ELSE RESUME 
590 DATE$="Start"
600 INPUT "ENTER INITIAL VALUE OF NOTE   ",PV#
610 PV$=STR$(PV#)
620 INPUT "ENTER ANNUAL RATE OF INTEREST (%)   ",I
630 INPUT "ENTER NO. OF PAYMENTS PER YEAR   ",P%
640 PRINT : INPUT "ANY CHANGES TO THE ABOVE? (Y/N) ";C$
650 IF C$="Y" OR C$="y" THEN PRINT : GOTO 590
660 PRINT STRING$(75,"=")
670 INTRATE=.01*I/P%
680 WRITE #1,INTRATE
690 WRITE #1,"  DATE","   AMT","AMT TO","AMT TO","PRINCIPAL","  CUMULAT."
700 WRITE #1,"  PAID","  PAID"," INT. ","PRNCPL","REMAINING"," INT. PAID"
710 WRITE #1,DATE$,PMT$,PERINT$,AMORT$,PV$,TOTINT$
720 CLOSE
730 RESUME 70
800 '-------------------------------------------------------------------------
802 'Printer output
805 OPEN "I",#1,"NOTE.DAT"
810 FLAG%=0
820 INPUT #1,INTRATE
830 IF EOF(1) THEN 970
840 FLAG%=FLAG%+1
850 INPUT #1,DATE$,PMT$,PERINT$,AMORT$,PV$,TOTINT$
860 IF FLAG%=3 THEN LPRINT 
870 IF FLAG%<3 THEN LPRINT DATE$,PMT$,PERINT$,AMORT$,PV$;TAB(70);TOTINT$ ELSE 890
880 GOTO 830
890 PMT=VAL(PMT$) : PERINT=VAL(PERINT$) : AMORT=VAL(AMORT$) : PV#=VAL(PV$)
900 TOTINT#=VAL(TOTINT$)
910 LPRINT DATE$;TAB(13);USING"#,###.##";PMT;
920 LPRINT TAB(27);USING"#,###.##";PERINT;  
930 LPRINT TAB(41);USING"#,###.##";AMORT;
940 LPRINT TAB(56);USING"###,###.##";PV#;
950 LPRINT TAB(70);USING"###,###.##";TOTINT#
960 GOTO 830
970 CLOSE
980 RETURN

940 LPRINT TAB(56);USING"###,###.##";PV#;
950 LPRINT TAB(70);USING"###,###.##";TOTINT#
960 GOTO 