10 PRINT CHR$(26)
20 PRINT ">>> SOLUTION OF SIMULTANEOUS LINEAR EQUATIONS USING GAUSS-JORDAN ELIMINATION <<<"
30 PRINT "             [ EQUATION FORM IS:  aX(1) + bX(2) + ... + nX(m) = K ]
40 DIM A(10,11)
50 PRINT 
60 PRINT 
70 PRINT "NUMBER OF UNKNOWNS";TAB(30);
80 INPUT N
90 IF N=0 THEN 470
100 'Input data
110 FOR R=1 TO N
120 PRINT 
130 PRINT "FOR EQUATION";R;":"
140 FOR C=1 TO N
150 PRINT "   COEFFICIENT OF TERM";C;TAB(30);
160 INPUT A(R,C)
170 NEXT C
180 PRINT "   CONSTANT";TAB(30);
190 INPUT A(R,N+1)
200 NEXT R
210 PRINT 
220 'Diagonalize
230 'One column at a time
240 FOR C1=1 TO N
250 GOSUB 510
260 'Each row except diagonal
270 FOR R1=1 TO N
280 IF R1=C1 THEN 350
290 M=A(R1,C1)/A(C1,C1)
300 A(R1,C1)=0
310 'For each coeff of equation
320 FOR C2=C1+1 TO N+1
330 A(R1,C2)=A(R1,C2)-M*A(C1,C2)
340 NEXT C2
350 NEXT R1
360 NEXT C1
370 'Print results
380 PRINT 
390 PRINT "SOLUTION:"
400 PRINT 
410 FOR R1=1 TO N
415 R1$=STR$(R1)
420 A(R1,N+1)=A(R1,N+1)/A(R1,R1)
430 A(R1,R1)=1
440 PRINT "    X(";MID$(R1$,2);") = ";A(R1,N+1)
450 NEXT R1
460 PRINT 
470 INPUT "RUN AGAIN (Y/N)";R$
480 IF R$="Y" OR R$="y" THEN PRINT CHR$(26) ELSE 660
490 GOTO 70
500 'SUBROUTINE: Put equation with largest coeff on top
510 L=C1
520 FOR R=C+1 TO N
530 IF ABS(A(R1,C1))<=ABS(A(L,C1)) THEN 550
540 L=R
550 NEXT R
560 IF A(L,C1)<>0 THEN 600
570 PRINT:PRINT "NO SOLUTION"
580 GOTO 470
590 'Interchange
600 FOR C=C1 TO N+1
610 H=A(C1,C)
620 A(C1,C)=A(L,C)
630 A(L,C)=H
640 NEXT C
650 RETURN
660 END
 470
590 'Interchange
600 FOR C=C1 TO N+1
610 H=A(C1,C)
620 A(C1,C)=A(L,C)
630 A(L,C)=H
640 NEXT C
650 RE