1 REM Corrected by Jim Woolley, FOG Disk Librarian, 8/82
1000 '                      SAVED AT MORTCOMP  30/03/82 1.0 TLB
1010 '                 MORTGAGE COMPARISON PROGRAM
1020 '      NOTE ROUNDING ERRORS MAY OCCUR IN COMPUTED NUMBERS
1030 ' ************************************************************
1040 '                     DATA INITIALIZATION
1050 ' ************************************************************
1060 PRINT "ENTER THE ITEM TO VARY: AMOUNT(A), INT RATE(I), OR YEARS(Y)"
1070 S1=1
1080 S2=1
1090 S3=1
1100 INPUT A$
1110 ' ************************************************************
1120 '                     ENTER VARIABLE ITEMS
1130 ' ************************************************************
1140 IF A$<>"A" THEN 1200
1150 PRINT "ENTER THE BEGINNING AMOUNT, ENDING AMOUNT TO CONSIDER"
1160 INPUT A0,A1
1170 PRINT "ENTER THE INTERVAL BETWEEN PRINTS; E.G., 1000"
1180 INPUT S1
1190 GOTO 1380
1200 IF A$<>"I" THEN 1260
1210 PRINT "ENTER THE LOWEST, HIGHEST INTEREST RATE TO CONSIDER"
1220 INPUT R0,R1
1230 PRINT "ENTER THE INTERVAL BETWEEN PRINTS; E.G., .25 FOR 1/4"
1240 INPUT S2
1250 GOTO 1340
1260 IF A$<>"Y" THEN 1320
1270 PRINT "ENTER THE LOWEST,HIGHEST NUMBER OF YEARS TO CONSIDER"
1280 INPUT Y0,Y1
1290 PRINT"ENTER THE INTERVAL BETWEEN PRINTS; E.G., 5"
1300 INPUT S3
1310 ' ************************************************************
1320 '                     ENTER CONSTANT ITEMS
1330 ' ************************************************************
1340 PRINT "ENTER THE MORTGAGE AMOUNT"
1350 INPUT P
1360 A0=P
1365 A1=A0:S1=1
1370 IF A$="I" THEN 1440
1380 PRINT "ENTER THE INTEREST RATE"
1390 INPUT I1
1400 IF I1>=1 THEN 1420
1410 I1=I1*100
1420 R0=I1
1425 R1=R0:S2=1
1430 IF A$="Y" THEN 1470
1440 PRINT "ENTER THE YEARS OF THE MORTGAGE"
1450 INPUT Y
1460 Y0=Y
1465 Y1=Y0:S3=1
1470 PRINT
1480 PRINT
1490 PRINT
1500 ' ************************************************************
1510 '                       PROCESSING LOOP
1520 ' ************************************************************
1530 FOR Y=Y0 TO Y1 STEP S3
1540   PRINT "FOR A MORTGAGE OF";Y;"YEARS"
1550   PRINT
1560   FOR I1=R0 TO R1 STEP S2
1570     PRINT "USING THE INTEREST RATE";I1;"%"
1580     PRINT
1590     PRINT "MORTGAGE";TAB(15);"MONTHLY PI";TAB(30);" TOTAL"
1600     PRINT "AMOUNT";TAB(15);" PAYMENT";TAB(30);"INTEREST"
1610     PRINT "--------";TAB(15);"----------";TAB(30);"----------"
1620     FOR P=A0 TO A1 STEP S1
1630       '  ******* COMPUTATION AND PRINT **********************
1640       I=(I1/100)/12
1650       M=I/((1+I)^(Y*12)-1)+I
1660       M1=M*P
1670       I3=M1*Y*12-P
1680       PRINT P;TAB(15);M1;TAB(30);I3
1690     NEXT P
1700     PRINT "****************************************"
1710     PRINT
1720   NEXT I1
1730 NEXT Y
1740 ' ************************************************************
1750 '                  PROGRAM TERMINATION POINT
1760 ' ************************************************************
1770 PRINT
1780 PRINT
1790 STOP
RAM TERMINATION