10 'CHARGES.BAS (ELECTRIC 1) OCT.1977 JOHN M.NEVISON
20 '
30 'THIS IS A STYLIZED VERSION OF A BASIC PLUS PROGRAM BY M. SHORE
40 '
50 'MODIFIED FOR ANY WIDTH TERMINAL / JOHN MESSINA 1982
60 '
70 'REF: DWYER,T. & CRITCHFIELD, M., BASIC & THE PERSONAL COMPUTER
80 '     READING, MASS: ADDISON WESLEY PUB. CO. 1978
90 '
100 '
110 'VARIABLES:
120 '  C(I)...SIZE OF CHARGE I
130 '  D......DISTANCE FROM POINT TO CHARGE
140 '  I,J....INDEX VARIABLES
150 '  N......NUMBER OF CHARGES
160 '  V......VALUE OF THE FIELD AT X,Y
170 '  X,Y....POSITION IN FIELD
180 '  (I)....POSITION OF  CHARGE
190 '  W......TERMINAL WIDTH (JDM 1983)
200 '
210 PRINT"  THIS PROGRAM GENERATES UNIQUE PATTERNS BY USING MATHEMATICAL FORMULAS
220 PRINT"THAT ILLUSTRATE AN ELECTRIC FIELD RESULTING FROM SEVERAL CHARGES.
230 PRINT
240 PRINT"  AN ELECTRIC FIELD POTENTIAL 'V' IS PROPORTIONAL TO THE CHARGE CAUSING
250 PRINT"THE FIELD, BUT INVERSELY PROPORTIONAL TO THE DISTANCE 'R' FROM THE 
260 PRINT"CHARGE.  WITH SEVERAL CHARGES, A SUM OF FIELD POTENTIALS IS TAKEN.
270 'EXAMPLE
280 'HOW MANY CHARGES? 5
290 '#1 X=20, Y=20
300 '#2 X=20, Y=60
310 '#3 X=60, Y=50
320 '#4 X=90, Y=20
330 '#5 X=90, Y=60
340 'TYPE AND SIZE OF EACH CHARGE?
350 '#2 = 1
360 '#3 = -2
370 '#4 = -1
380 '#5 = 1
390 '
400 '*** MAIN PROGRAM
410 PRINT
420 INPUT "TERMINAL WIDTH (# CHARACTERS)";W
430 'PLOT THE ELECTRIC FIELD THAT SURROUNDS A SET OF POINT CHARGES
440 INPUT"HOW MANY CHARGES DO YOU HAVE (0=END)";N
450 IF N=0 THEN SYSTEM 'END PROGRAM
460 FOR I=1 TO N
470 PRINT"CENTER IS X=";W;"VERTICAL  -  Y=";W/2;" HORIZONTAL
480 PRINT "TYPE IN THE X AND Y POSITIONS OF CHARGE ";I
490 INPUT"X";X(I)
500 INPUT"Y";Y(I)
510 NEXT I
520 FOR I=1 TO N
530 X(I)=X(I) * SQR(3)/2
540 NEXT I
550 PRINT "SIZE SHOULD BE IN RANGE OF -3 TO +3
560 PRINT "ENTER THE SIZE OF EACH CHARGE (Q)
570 FOR I=1 TO N
580 PRINT "CHARGE ";I;
590 INPUT C(I)
600 NEXT I
610 FOR J=1 TO 2 * W STEP 2
620 X=J * SQR(3)/2
630 FOR Y=1 TO W ' LAST NUMBER IS TERMINAL WIDTH *********
640 GOSUB 820
650 V= (V+1) * 50
660 IF V>= 32 THEN 680
670 V=32
680 '
690 IF V<=126 THEN 710
700 V=126
710 '
720 B$=CHR$(V)
730 IF V<=INT(V)+.5 THEN 750
740 B$=" "
750 '
760 PRINT B$;
770 NEXT Y
780 PRINT
790 NEXT J
800 '
810 GOTO 440
820 'REM SUBROUTINE: CHARGE AT POINT
830 'IN X,Y,X(),Y(),C()
840 'OUT: V
850 'CALCULATE THE TOTAL CHARGE, V AT A POINT (X,Y) IN FIELD
860 V=0
870 FOR I=1 TO N
880 D=SQR((X-X(I))^2 + (Y-Y(I))^2)
890 IF D=0 THEN 940
900 V=V+ C(I)/D
910 GOTO 940   'THEN BOTTOM
920 V=99999!
930 GOTO 950    'LOOP EXIT
940 NEXT I
950 RETURN
 D=0 THEN 940
900 V=V+ C(I)/D
910 GOTO 940   'THEN BOTOM
920 V=99999!
930 GOTO 950    'LOOP EXIT
940 NEXT I
950 RETURN
 D=0 THEN 940
900 V=V+ C(I)/D
910 GOTO 940   'THEN BO