5 'KA1GT PARAMETRIC DESIGN PROGRAM FOR LOOP YAGI
7 PRINT CHR$(26)
8 PRINT "PARAMETRIC DESIGN PROGRAM FOR 27 OR 38 ELEMENT LOOP YAGI" : PRINT 
10 DIM A(38),B(36),L(36),L1(36)
20 A(1)=3.1 : A(2)=4.05 : A(3)=5.17 : A(4)=6!
25 A(5)=7.78 : A(6)=9.56 : A(7)=10.81 : A(8)=13.12
30 FOR X=1 TO 30
40 A(X+8)=13.12+X*3.56
50 NEXT
60 INPUT "FREQUENCY OF USE? (MHz) ",F
70 FC=1296/F
72 FOR X=1 TO 38
75 A(X)=A(X)*FC
77 NEXT
80 R1=9.67
90 DE=9.23
110 FOR X=1 TO 11
120 B(X)=8.25
130 NEXT
140 INPUT "27 OR 38 ELEMENT VERSION? ",N
142 IF N<>27 AND N<>38 GOTO 140
150 FOR X=12 TO 18
160 B(X)=8!
170 NEXT
180 IF N=27 THEN GOSUB 500
190 IF N=38 THEN GOSUB 600
200 FOR X=1 TO 36
210 B(X)=B(X)*FC
215 NEXT
220 R1=R1*FC
230 DE=DE*FC
240 INPUT "BOOM DIAMETER? (IN.) ",B
250 INPUT "ELEMENT WIDTH? (IN.) ",W
260 INPUT "ELEMENT THICKNESS? (IN.) ",T
265 PRINT : PRINT 
270 B1=B/FC : W1=W/FC : T1=T/FC
280 IF B1<.5 OR B1>2.1 THEN GOSUB 700
300 IF T1<.028 OR T1>.063 THEN GOSUB 750
320 IF W1<.1 OR W1>.375 THEN GOSUB 800
340 B2=((B1-.5)+(B1-.5)^2)*2.88
350 FOR X=1 TO (N-2)
360 B(X)=B(X)+(B(X)/100)*B2
365 NEXT
370 DE=DE+DE*B2/100
380 R1=R1+R1*B2/100
390 W2=(.1875-W1)*4.8
400 FOR X=1 TO (N-2)
410 B(X)=B(X)+(B(X)/100)*W2
420 NEXT
422 DE=DE+DE*W2/100
424 R1=R1+R1*W2/100
430 T2=(T1-.028)*(.6/.031)
440 FOR X=1 TO (N-2)
450 B(X)=B(X)+((B(X)/100)*T2)
460 NEXT
470 DE=DE+DE*T2/100
475 R1=R1+R1*T2/100
485 RA=FC*4.5 : RB=FC*5.5
495 GOTO 1000
500 FOR X=19 TO 25
510 B(X)=8!
520 NEXT
530 RETURN
600 FOR X=19 TO 36
610 B(X)=7.7
620 NEXT
630 RETURN
700 PRINT "BOOM DIAMETER OUTSIDE RANGE OF PARAMETRIC STUDY.
705 PRINT "CALCULATION CONTINUES WITH EXTRAPOLATED DATA." : PRINT 
710 RETURN
750 PRINT "MATERIAL THICKNESS OUTSIDE RANGE OF PARAMETRIC STUDY.
755 PRINT "CALCULATION CONTINUES WITH EXTRAPOLATED DATA.": PRINT 
760 RETURN
800 PRINT "ELEMENT WIDTH OUTSIDE RANGE OF PARAMETRIC STUDY."
805 PRINT "CALCULATION CONTINUES WITH EXTRAPOLATED DATA." : PRINT 
810 RETURN
1000 PRINT "DATA FOR LOOP YAGI FOR USE AT";F;"MHz"
1010 PRINT 
1020 PRINT "BOOM DIAMETER:      ";B;"IN."
1030 PRINT "ELEMENT WIDTH:      ";W;"IN."
1040 PRINT "ELEMENT THICKNESS:  ";T;"IN."
1042 PRINT "REFLECTOR SCREEN:   ";(INT(RA*1000))/1000;" x ";(INT(RB*1000))/1000;"IN."
1043 PRINT : PRINT "ALL DIMENSIONS IN INCHES" : PRINT 
1045 INPUT "Press any key to continue",K$
1046 PRINT : PRINT "ALL DIMENSIONS IN INCHES" : PRINT 
1047 PRINT "ELEMENT";TAB(11);"DISTANCE";TAB(21);"LENGTH";TAB(40);"ELEMENT";TAB(51);"DISTANCE";TAB(61);"LENGTH"
1048 PRINT TAB(11);"FROM SCRN";TAB(21);"(CIRCUMF.)";TAB(51);"FROM SCRN";TAB(61);"(CIRCUMF.)"
1050 PRINT "R1";TAB(10);(INT(A(1)*1000))/1000;TAB(20);(INT(R1*1000))/1000
1060 PRINT "DE";TAB(10);(INT(A(2)*1000))/1000;TAB(20);(INT(DE*1000))/1000
1070 FOR X=1 TO (N-2)
1075 L(X)=(INT(B(X)*1000))/1000
1076 L1(X)=(INT(A(X+2)*1000))/1000
1090 NEXT
1095 IF N=38 THEN NN=18 ELSE NN=12
1100 FOR X=1 TO NN
1110 PRINT "D";X;TAB(10);L1(X);TAB(20);L(X);TAB(40);"D";X+NN;TAB(50);L1(X+NN);TAB(60);L(X+NN)
1120 NEXT 
1130 IF N=27 THEN PRINT TAB(40);"D 25";TAB(50);L1(25);TAB(60);L(25)
1140 END
N;TAB(50);L1(X+NN);TAB(60);L(X+NN)
1120 NEXT 
1130 IF